unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DirectShow9, ActiveX, StdCtrls;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    Function GetAudioTracks:Integer;
    Procedure initial;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

   //     
  pGraphBuilder        : IGraphBuilder         = nil; // 
  pMediaControl        : IMediaControl         = nil; // 
  pMediaEvent          : IMediaEvent           = nil; // 
  pVideoWindow         : IVideoWindow          = nil; //   
  pMediaPosition       : IMediaPosition        = nil; // 
  pBasicAudio          : IBasicAudio           = nil; // 
 
  hr: HRESULT = 1; //   
  FileName: string;


implementation

{$R *.dfm}

Procedure TForm1.initial;
begin
//  
  if Assigned(pMediaPosition) then pMediaPosition := nil;
  if Assigned(pBasicAudio) then pBasicAudio  := nil;
  if Assigned(pVideoWindow) then pVideoWindow := nil;
  if Assigned(pMediaEvent) then pMediaEvent := nil;
  if Assigned(pMediaControl) then pMediaControl := nil;
  if Assigned(pGraphBuilder) then pGraphBuilder := nil;
//   
  hr := CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, pGraphBuilder);
  if hr<>0 then begin
    ShowMessage('   ');
    exit;
  end;

//  
  hr := pGraphBuilder.QueryInterface(IID_IMediaControl, pMediaControl);
  if hr<>0 then begin
    ShowMessage('    IMediaControl');
    exit;
  end;
//  
   hr := pGraphBuilder.QueryInterface(IID_IMediaEvent, pMediaEvent);
   if hr<>0 then begin
    ShowMessage('    ');
    exit;
  end;
//     
  hr := pGraphBuilder.QueryInterface(IID_IVideoWindow, pVideoWindow);
  if hr<>0 then begin
    ShowMessage('   IVideoWindow');
    exit;
  end;
//   
   hr := pGraphBuilder.QueryInterface(IBasicAudio, pBasicAudio);
  if hr<>0 then begin
    ShowMessage('    ');
    exit;
  end;
//     
  hr := pGraphBuilder.QueryInterface(IID_IMediaPosition, pMediaPosition);
   if hr<>0 then begin
    ShowMessage('     ');
    exit;
  end;


//   
  hr := pGraphBuilder.RenderFile(StringToOleStr(PChar(FileName)), '');
  if hr<>0 then begin
    ShowMessage('   ');
    exit;
  end;

//     
   pVideoWindow.Put_Owner(Panel1.Handle);// "" ,    Panel1
   pVideoWindow.Put_WindowStyle(WS_CHILD OR WS_CLIPSIBLINGS);// 
   pVideoWindow.put_MessageDrain(Panel1.Handle);//  Panel1     
   pVideoWindow.SetWindowPosition(0,0,Panel1.ClientRect.Right,Panel1.ClientRect.Bottom); //


end;

//    
Function TForm1.GetAudioTracks:Integer;
var
  pEnum : IEnumFilters;
  pFilter :IBaseFilter;
  cFetched : dword;
  CL:TGUID;
begin
result:=0;
  // Get filter enumerator
  pGraphBuilder.EnumFilters(pEnum);
  while pEnum.Next(1, pFilter, @cFetched) = S_OK do
  begin
      pFilter.GetClassID(CL);
      if IsEqualGUID(CL,CLSID_DSoundRender) then
      begin
      inc(Result);
      Listbox1.Items.Add(inttostr(Result));
      end;
      pFilter:=nil;
  end;
  pFilter:=nil;
  pEnum:=nil;

end;
//     CLSID_DSoundRender    .
Procedure SetAudioTrack(i:integer);
var
  pEnum : IEnumFilters;
  pFilter :IBaseFilter;
  cFetched : dword;
  CL:TGUID;
  n:integer;
begin
  n:=0;
  // Get filter enumerator
  pGraphBuilder.EnumFilters(pEnum);
  while pEnum.Next(1, pFilter, @cFetched) = S_OK do
  begin
      pFilter.GetClassID(CL);
      if (IsEqualGUID(CL,CLSID_DSoundRender))  then
        begin
        n:=n+1;
        if n<>i then  pGraphBuilder.RemoveFilter(pFilter);
        end;
       pFilter:=nil;
  end;
  pFilter:=nil;
  pEnum:=nil;

end;

procedure TForm1.Button1Click(Sender: TObject);

begin
//  
  if Assigned(pMediaPosition) then pMediaPosition := nil;
  if Assigned(pBasicAudio) then pBasicAudio  := nil;
  if Assigned(pVideoWindow) then pVideoWindow := nil;
  if Assigned(pMediaEvent) then pMediaEvent := nil;
  if Assigned(pMediaControl) then pMediaControl := nil;
  if Assigned(pGraphBuilder) then pGraphBuilder := nil;
//   
  hr := CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, pGraphBuilder);
  if hr<>0 then begin
    ShowMessage('   ');
    exit;
  end;

  if not (OpenDialog1.Execute) then exit;
 FileName:=OpenDialog1.FileName;
//   
  hr := pGraphBuilder.RenderFile(StringToOleStr(PChar(FileName)), '');
  if hr<>0 then begin
    ShowMessage('   ');
    exit;
  end;

//  
 GetAudioTracks;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
CoUninitialize;//  OLE

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 CoInitialize(nil);//  OLE

end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
initial;
// 
SetAudioTrack(listbox1.ItemIndex+1);
//  
pMediaControl.Run;
end;

end.
